      subroutine plw3j(imode,isel)
      implicit none

      INCLUDE 'inclk.h'
      INCLUDE 'grchad.inc'

      INTEGER MXDIM,NDMX,NDIM,NWILD,IG,NCALL,ITMX1,ITMX2
      DOUBLE PRECISION XL,XU,ACC1,ACC2
      PARAMETER (MXDIM = 50, NDMX = 50 )
      COMMON /BPARM1/ XL(MXDIM),XU(MXDIM),NDIM,NWILD,
     $     IG(MXDIM),NCALL
      COMMON /BPARM2/ ACC1,ACC2,ITMX1,ITMX2

      INTEGER JPROC
      COMMON /AMJPRC/JPROC

      CHARACTER GRCPROC*40
      COMMON/GRCCHAR/GRCPROC

      INTEGER i,imode,isel
      real*8  xsn(10),rna
      integer imrg,ijrg


C...Decide subprocess ID.
      if (imode.eq.1) then
         ijrg = 430
C...Include all configuration in W + 3jets.
         imrg = 8
         xsn(2) = 0.40d0        ! 432
         xsn(3) = 0.46d0        ! 433
         xsn(4) = 0.60d0        ! 434
         xsn(5) = 0.76d0        ! 435
         xsn(6) = 0.82d0        ! 436
         xsn(7) = 0.88d0        ! 437
         xsn(8) = 0.94d0        ! 438
C...Inclusive heavy flavor production.
         if (igjflv(7).eq.0) then
            imrg = 7
            xsn(2) = 0.32d0     ! 432
            xsn(3) = 0.40d0     ! 433
            xsn(4) = 0.56d0     ! 435
            xsn(5) = 0.76d0     ! 436
            xsn(6) = 0.84d0     ! 437
            xsn(7) = 0.92d0     ! 438
         endif

         rna = xrun(14)
         xsn(1) = 0.0d0
         xsn(imrg+1) = 1.0d0
         do i = 1,imrg
            if (rna.gt.xsn(i).and.rna.le.xsn(i+1)) then
               gpri(10) = (rna-xsn(i))/(xsn(i+1)-xsn(i))
               yacob = yacob/(xsn(i+1)-xsn(i))
               jproc = i + ijrg
            endif
         enddo

C...Inclusive heavy flavor production.
         if (igjflv(7).eq.0) then
            if (jproc.eq.437) jproc = 438
            if (jproc.eq.436) jproc = 437
            if (jproc.eq.435) jproc = 436
            if (jproc.eq.434) jproc = 435
         endif

C...Set dimension and process character.
      else if (imode.eq.2) then
         ndim = 16
         if (isel.eq.103) grcproc = 'pp(bar)->W(2f) + 3 jets'
         if (isel.eq.431) grcproc = 'qg -> W(2f) +qgg(ELWK2,QCD3)'
         if (isel.eq.432) grcproc = 'qg -> W(2f) +qqq(ELWK2,QCD3)'
         if (isel.eq.433) grcproc = 'qq -> W(2f) +qqg(ELWK2,QCD3)'
         if (isel.eq.434) grcproc = 'qq -> W(2f) +ggg(ELWK2,QCD3)'
         if (isel.eq.435) grcproc = 'gg -> W(2f) +qqg(ELWK2,QCD3)'
         if (isel.eq.436) grcproc = 'qq -> W(2f) +qqg(ELWK2,QCD3)'
         if (isel.eq.437) grcproc = 'qq -> W(2f) +qqg(ELWK2,QCD3)'
         if (isel.eq.438) grcproc = 'qq -> W(2f) +qqg(ELWK2,QCD3)'

C...Initialize kinematic parameter.
      else if (imode.eq.3) then
         mxreg = 1
         ktype = 2501
         cxtype = 1234567
         gtau(1) = 1
         gtau(14) = 2
         gyst(1) = 1
         gyst(14) = 5
         gcos3(1) = 1
         gcos3(14) = 4
         gq12(1) = 1
         gq12(2) = 2.0d0**2
         gq12(14) = 10
         gq22(1) = 1
         gq22(2) = 2.0d0**2
         gq22(14) = 2
         gspr(1) = 1
         gspr(2) = 1
         gspr(3) = 2
         geps(3) = 5.0d-2

         if (igjflv(1)+igjflv(2)+igjflv(3)+igjflv(4)
     $        +igjflv(5)+igjflv(7).eq.0.and.igjflv(6).eq.1) then
            ktype = 2502
            gtau(2) = amuq(3)**2/grcecm**2
         endif

C...Set flavor and if necessary, decide weight of each phase space.
      else if (imode.eq.4) then
         isel = 1
      endif

      return
      end
